# keystoneauth1.loading.base module

class keystoneauth1.loading.base.BaseLoader

  Bases: `_BaseLoader`[`BaseAuthPluginT`]

  __abstractmethods__ = frozenset({'get_options'})
  __annotate_func__ = None
  __annotations_cache__ = {}
  __doc__ = None
  __firstlineno__ = 219
  __module__ = 'keystoneauth1.loading.base'
  __orig_bases__ = (keystoneauth1.loading.base._BaseLoader[+BaseAuthPluginT],)
  __parameters__ = (+BaseAuthPluginT,)
  __static_attributes__ = ()
  _abc_impl = <_abc._abc_data object>

keystoneauth1.loading.base.get_available_plugin_loaders() → dict[str, BaseLoader[BaseAuthPluginT]]

  Retrieve all the plugin classes available on the system.

  Returns:

    A dict with plugin entrypoint name as the key and the plugin loader as the value.

  Return type:

    dict

keystoneauth1.loading.base.get_available_plugin_names() → frozenset[str]

  Get the names of all the plugins that are available on the system.

  This is particularly useful for help and error text to prompt a user for example what plugins they may specify.

  Returns:

    A list of names.

  Return type:

    frozenset

keystoneauth1.loading.base.get_plugin_loader(name: str) → BaseLoader[BaseAuthPluginT]

  Retrieve a plugin class by its entrypoint name.

  Parameters:

    name (str) – The name of the object to get.

  Returns:

    An auth plugin class.

  Return type:

    `keystoneauth1.loading.BaseLoader`

  Raises:

    keystoneauth1.exceptions.auth_plugins.NoMatchingPlugin – if a plugin cannot be created.

keystoneauth1.loading.base.get_plugin_options(name: str) → list[opts.Opt]

  Get the options for a specific plugin.

  This will be the list of options that is registered and loaded by the specified plugin.

  Returns:

    A list of `keystoneauth1.loading.Opt` options.

  Raises:

    keystoneauth1.exceptions.auth_plugins.NoMatchingPlugin – if a plugin cannot be created.

this page last updated: 2026-07-14 15:48:40

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug